package spider;

import java.io.File;
import java.io.IOException;
import java.sql.SQLException;
import java.util.*;

import com.mingxue.spider.helper.Convert;
import com.mingxue.spider.helper.StringUtils;
import org.apache.commons.lang3.ArrayUtils;
import org.junit.Test;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.mingxue.spider.utils.ApiUtil;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.thread.ThreadUtil;
import cn.hutool.core.util.CharsetUtil;
import cn.hutool.db.DbUtil;
import cn.hutool.db.Entity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.util.CollectionUtils;

public class CollegeData {
    private static String host = "https://apiv4.diyigaokao.com";

    private List<String> errors = new ArrayList<>();
    protected final Logger log = LoggerFactory.getLogger(this.getClass());
    Boolean isBatchInsert = false;

    @Test
    public void test() throws Exception {
//        getMajorData();
        /**
         * {"error":0,"data":[{"code":"34","provinceSpell":"anhui","id":12,"provinceName":"安徽"},{"code":"09","provinceSpell":"aomen","id":34,"provinceName":"澳门"},{"code":"11","provinceSpell":"beijing","id":1,"provinceName":"北京"},{"code":"50","provinceSpell":"chongqing","id":22,"provinceName":"重庆"},{"code":"35","provinceSpell":"fujian","id":13,"provinceName":"福建"},{"code":"62","provinceSpell":"gansu","id":28,"provinceName":"甘肃"},{"code":"44","provinceSpell":"guangdong","id":19,"provinceName":"广东"},{"code":"45","provinceSpell":"guangxi","id":20,"provinceName":"广西"},{"code":"52","provinceSpell":"guizhou","id":24,"provinceName":"贵州"},{"code":"46","provinceSpell":"hainan","id":21,"provinceName":"海南"},{"code":"13","provinceSpell":"hebei","id":3,"provinceName":"河北"},{"code":"23","provinceSpell":"heilongjiang","id":8,"provinceName":"黑龙江"},{"code":"41","provinceSpell":"henan","id":16,"provinceName":"河南"},{"code":"42","provinceSpell":"hubei","id":17,"provinceName":"湖北"},{"code":"43","provinceSpell":"hunan","id":18,"provinceName":"湖南"},{"code":"32","provinceSpell":"jiangsu","id":10,"provinceName":"江苏"},{"code":"36","provinceSpell":"jiangxi","id":14,"provinceName":"江西"},{"code":"22","provinceSpell":"jilin","id":7,"provinceName":"吉林"},{"code":"21","provinceSpell":"liaoning","id":6,"provinceName":"辽宁"},{"code":"15","provinceSpell":"neimenggu","id":5,"provinceName":"内蒙古"},{"code":"64","provinceSpell":"ningxia","id":30,"provinceName":"宁夏"},{"code":"63","provinceSpell":"qinghai","id":29,"provinceName":"青海"},{"code":"61","provinceSpell":"shaanxi","id":27,"provinceName":"陕西"},{"code":"37","provinceSpell":"shandong","id":15,"provinceName":"山东"},{"code":"31","provinceSpell":"shanghai","id":9,"provinceName":"上海"},{"code":"14","provinceSpell":"shanxi","id":4,"provinceName":"山西"},{"code":"51","provinceSpell":"sichuan","id":23,"provinceName":"四川"},{"code":"07","provinceSpell":"taiwan","id":32,"provinceName":"台湾"},{"code":"12","provinceSpell":"tianjin","id":2,"provinceName":"天津"},{"code":"08","provinceSpell":"xianggang","id":33,"provinceName":"香港"},{"code":"65","provinceSpell":"xinjiang","id":31,"provinceName":"新疆"},{"code":"54","provinceSpell":"xizang","id":26,"provinceName":"西藏"},{"code":"53","provinceSpell":"yunnan","id":25,"provinceName":"云南"},{"code":"33","provinceSpell":"zhejiang","id":11,"provinceName":"浙江"}]}
         */

        /**
         * 生成九科数据
         */
//        generateNineDate();
        //         getCategoryMajor();

        /**
         * 湖南
         */
//        ApiUtil.getInstance().login();

        /**
         * 广东账号：18774924158，密码：123456
         */
//         ApiUtil.getInstance().login("18774924158", "123456",false,true);
//
        /**
         * 湖北账号：18674898114， 密码：123456
         */
//         ApiUtil.getInstance().login("18674898114", "123456",false,true);
        /**
         * 江西账号：13203226079，密码：123456
         */
//        ApiUtil.getInstance().login("13203226079", "123456",false,false);
        /**
         * 山西：17195878932，79844852
         */
//        ApiUtil.getInstance().login("17195878932", "79844852",false,false);
        /**
         * 贵州：17195865122，90320435
         */
        // ApiUtil.getInstance().login("17195865122", "90320435",false,false);
        /**
         * 安徽账号：13974960101，69280668
         */
        // ApiUtil.getInstance().login("13974960101", "69280668",false,false);
        /**
         * 河北账号：13437248803，41186990
         */
         ApiUtil.getInstance().login("13437248803", "41186990",false,true);
        collegeList();
    }
//181
    public void collegeList() throws SQLException {
//        int count = 0, total = 5000, page = 79;
        Integer ProvinceId=4;
        String Location="山西";//湖北的1-5页之前需要修正ProvinceId,表示学校所在省份
        int count = 0, total = 5000, page = 1;
        JSONObject res=new JSONObject();
        do {
            try {
                StringBuilder sb = new StringBuilder(host);
                sb.append("/college/list/byMultiple");
                sb.append("?provinceIds=&yxjbz=&levels=&collegeType=&hotTags=");
                sb.append("&pageIndex=").append(page).append("&pageSize=15");
                ThreadUtil.safeSleep(2 * 1000);

                res = ApiUtil.getInstance().httpSyncGet(sb.toString());
                total = res.getInteger("total");
                JSONArray data = res.getJSONArray("data");
                int processColledgeCount=0;
                for (int i = 0; i < data.size(); i++) {
                    long start = System.currentTimeMillis();
                    JSONObject row = data.getJSONObject(i);
                    final Integer collegeId = row.getInteger("id");
                    Entity entity = DbUtil.use().get("college", "id", collegeId);
                    if (null == entity) {
//                        detail(collegeId, 0);
                        ThreadUtil.safeSleep(1 * 1000);
                    }
                    /**
                     * 选科数据 xuanke(collegeId);
                     */
                    List<Integer> colledgeIds = Arrays.asList(
                            2391,2392,2393,2394,2395,2396,2397,2398,2399,2400);
                    if(colledgeIds.contains(collegeId)){
//                        continue;
                    }
                    if(processColledgeCount>5){
                        //超过5个学校换个账号
//                        ApiUtil.getInstance().login();
//                        processColledgeCount=0;
                    }

                    List<Integer> liberalScienceList= Arrays.asList(0,1);
                    List<Integer> typeList= Arrays.asList(2,3);
                    for(Integer liberalScience:liberalScienceList){
                        if(ApiUtil.getInstance().getUser().getIsNewGaokao()){
                            /**
                             * 院校录取数据：新高考
                             */
                            for(Integer type:typeList){
                                byHistoryNew(collegeId,liberalScience,type,Location,ProvinceId);
                            }
                        }else {
                            /**
                             * 院校录取数据：非新高考
                             * type 类型，普通省份(非新高考)不传或传1
                             */
                            byHistoryNew(collegeId,liberalScience,1,Location,ProvinceId);
                        }


                        /**
                         * 专业录取数据
                         */
                        byCollege(collegeId,liberalScience,2,Location,ProvinceId);
                        /**
                         * 招生计划数据
                         */
                        byCollege(collegeId,liberalScience,3,Location,ProvinceId);
                    }
                    processColledgeCount++;

                    ThreadUtil.safeSleep(1 * 1000);
                    log.error("{} 学校 {}, {}, 耗时{}",i+1,collegeId,row.getString("collegeName"),DateUtil.formatBetween(System.currentTimeMillis() - start));
                }
                log.error("已完成page={}, 开始第{}页" ,page,(page+1));
                count = page * 15;
                page += 1;
            } catch (IOException e) {
                e.printStackTrace();
                log.error("error res is {}",res);
                return;
            }
        } while (count <= total);
        File dir = new File("E:/projects/wangmin/evaluation/code/spider/");
        FileUtil.writeLines(errors, new File(dir, ApiUtil.getInstance().getUser().getCode() + ".txt"), CharsetUtil.CHARSET_UTF_8);
        System.out.println("执行完成!");
    }

    //字体编码
    static Map<Integer,String> fontMap = new HashMap<Integer, String>(){{
            put(1, "0923546781");
            put(2, "0329547681");
            put(3, "0359247681");
            put(4, "0351426789");
        }
    };

    private static String getRealData(Integer fontId, String data){
        if(StringUtils.isBlank(data)){
            return data;
        }
        StringBuilder result = new StringBuilder();
        for(char index:data.toCharArray()){
            result.append(fontMap.get(fontId).toCharArray()[Integer.parseInt(String.valueOf(index))]);
        }
        return result.toString();
    }

    /*
     * 院校录取数据
     * Request URL: https://apiv4.diyigaokao.com/query/collegeScore/byHistoryNew?liberalScience=1&collegeId=1&type=2
     * collegeId 院校ID true（必传） integer
     * liberalScience 科类： 1理科(物理)，0文科(历史), 2文理不分;  true integer
     * accessToken accessToken令牌 header false string
     * phase 批次 false integer
     * type 类型，普通省份不传或传1；312院校专业组省份(江苏、湖南、湖北、广东、福建):2021年以后数据传2，2020年以前数据传3 query false integer
     */
    private void byHistoryNew(Integer collegeId,Integer liberalScience,Integer type,String Location,Integer ProvinceId) throws IOException {
//        ThreadUtil.safeSleep(2 * 1000);

        StringBuilder sb = new StringBuilder(host);
        if(ApiUtil.getInstance().getUser().getIsNewGaokao()){
            //新高考
            sb.append("/query/collegeScore/byHistoryNew");
        }else {
            //非新高考
            sb.append("/query/collegeScore/byHistory");
        }
        sb.append("?liberalScience=").append(liberalScience);
        sb.append("&collegeId=").append(collegeId);
        sb.append("&type=").append(type);
        JSONObject res = ApiUtil.getInstance().httpSyncGet(sb.toString());
//        System.out.println("data is "+res);
        if(res.getInteger("error")==0){
            //data
            JSONObject dataObject = res.getJSONObject("data");
            JSONArray tdDatas = dataObject.getJSONArray("tdData");
            JSONArray thDatasArray = dataObject.getJSONArray("thData");
            JSONObject thData1=new JSONObject(){{//增加最低/最高分数据解析
                put("label","最低投档分");
                put("prop","LowestScore");
                put("encryption",1);
            }};
            thDatasArray.add(thData1);
            JSONObject thData2=new JSONObject(){{//增加最低/最高分数据解析
                put("label","最高投档分");
                put("prop","MajorScoreCount");
                put("encryption",1);
            }};
            thDatasArray.add(thData2);

            //font
            JSONObject font = res.getJSONObject("font");
            Integer fontId = font.getInteger("id");
            String fontValue = fontMap.get(fontId);

            Set<Entity> subjectList=new HashSet();
            for (int i = 0; i < tdDatas.size(); i++) {
                //sy_colledge_enroll_data
                JSONObject row = tdDatas.getJSONObject(i);
                row.put("Location",Location);
                row.put("type",type);
                row.put("font_id",fontId);
                row.put("font_value",fontValue);
                row.put("update_time",new Date());
                //解密错位数据
                replaceEncryptDate(fontId,row,thDatasArray);

                Entity subjectTable4 = Entity.create("sy_colledge_enroll_data");
                subjectTable4.putAll(row);
                subjectList.add(subjectTable4);
                if(!isBatchInsert){
                    try {
//                        DbUtil.use().insertOrUpdate(subjectTable4, "ID");
                        DbUtil.use().insert(subjectTable4);
                    } catch (SQLException e) {
                        e.printStackTrace();
                    }
                }
            }
            if(isBatchInsert){
                try {
                    if(!CollectionUtils.isEmpty(subjectList)){
                        DbUtil.use().insert(subjectList);
                    }
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }else {
            log.error("byHistoryNew res is {}, request is {}  ",res,sb.toString());
        }
    }

    /**
     * 将数据替换为真实值
     * @param fontId
     * @param row
     * @param thDatasArray
     * @return
     */
    private JSONObject replaceEncryptDate(Integer fontId,JSONObject row,JSONArray thDatasArray){
        //解密错位数据
        thDatasArray.forEach(m->{
            JSONObject thDatasJSONObject = (JSONObject) m;
            if(thDatasJSONObject.getInteger("encryption")==1){
                String prop = thDatasJSONObject.getString("prop");
                String originalValue = row.getString(prop);
                if(StringUtils.isNotBlank(originalValue)){
                    String realValue=getRealData(fontId,originalValue);
                    row.put(prop,realValue);
                }
            }
        });

        return row;
    }

    /**
     * 专业录取数据
     * @param collegeId
     * @param liberalScience
     * @throws IOException
     */
    private void byCollege(Integer collegeId,Integer liberalScience,Integer queryType,String Location,Integer ProvinceId) throws IOException {
        ThreadUtil.safeSleep(2 * 1000);

        StringBuilder sb = new StringBuilder(host);
//        sb.append("/years");
//        sb.append("?queryType=").append(queryType);
//        sb.append("&provinceId=").append("18");
//        JSONObject res = ApiUtil.getInstance().httpSyncGet(sb.toString());
        JSONObject res = new JSONObject();
//        if(res.getInteger("error")==0){
            //data
//            JSONArray dataYearArray = res.getJSONArray("data");
//            for (int j = 0; j < dataYearArray.size(); j++) {
//                JSONObject dataJSONObject = dataYearArray.getJSONObject(j);
//                int yearLast= Calendar.getInstance().getWeekYear()-1;//补充上一个年份
//                dataJSONObject.put("id",yearLast);
//                dataJSONObject.put("year",yearLast);
//                Integer year = dataJSONObject.getInteger("year");
            List<Integer> yearList = Arrays.asList(2021,2020,2019);
            for(int year:yearList){
                sb = new StringBuilder(host);
                if(queryType==2){
                    sb.append("/query/majorScore/byCollege");
                }else if(queryType==3){
                    sb.append("/query/majorPlan/byCollege");

                }
                sb.append("?provinceId=").append(ProvinceId);
                sb.append("&collegeId=").append(collegeId);
                sb.append("&liberalScience=").append(liberalScience);
                sb.append("&year=").append(year);
                sb.append("&pageIndex=").append(1);
                sb.append("&pageSize=").append(100);
                res = ApiUtil.getInstance().httpSyncGet(sb.toString());
//        System.out.println("data is "+res);
                JSONObject rows = res.getJSONObject("data");
                if(res.getInteger("error")==0){
                    JSONArray tdDatas = rows.getJSONArray("tdData");
                    JSONArray thDatasArray = rows.getJSONArray("thData");
                    if(queryType==2){
                        JSONObject thData1=new JSONObject(){{//增加最低/最高分数据解析
                            put("label","平均投档分");
                            put("prop","AvgScore");
                            put("encryption",1);
                        }};
                        thDatasArray.add(thData1);
                        JSONObject thData2=new JSONObject(){{//增加最低/最高分数据解析
                            put("label","最高投档分");
                            put("prop","MajorScoreCount");
                            put("encryption",1);
                        }};
                        thDatasArray.add(thData2);
                    }

                    //font
                    JSONObject font = res.getJSONObject("font");
                    Integer fontId = font.getInteger("id");
                    String fontValue = fontMap.get(fontId);

                    Set<Entity> subjectList=new HashSet();
                    for (int i = 0; i < tdDatas.size(); i++) {
                        //sy_colledge_enroll_data
                        JSONObject row = tdDatas.getJSONObject(i);
//                        System.out.println("colledgeCode："+row.getString("CollegeCode"));
                        if(queryType==3){
//                            row.remove("AvgScore");
//                            row.remove("HighestScore");
//                            row.remove("LiberalScience");
//                            row.remove("LowestScore");
//                            row.remove("LowestScoreRank");
//                            row.remove("LowestScore");
//                            row.remove("LowestScore");
                        }
//                        row.put("ProvinceId",ProvinceId);//湖南
                        row.put("Location",Location);//湖南
                        row.put("font_id",fontId);
                        row.put("font_value",fontValue);
                        row.put("update_time",new Date());
                        //解密错位数据
                        replaceEncryptDate(fontId,row,thDatasArray);

                        String tableName = StringUtils.EMPTY;
                        if(queryType==2){
                            tableName = "sy_colledge_major_enroll_data";
                        }else if(queryType==3){
                            tableName = "sy_colledge_recruit_data";
                        }
                        Entity subjectTable4 = Entity.create(tableName);
                        subjectTable4.putAll(row);
                        subjectList.add(subjectTable4);
                        if(!isBatchInsert){
                            try {
//                                DbUtil.use().insertOrUpdate(subjectTable4, "ID");
                                DbUtil.use().insert(subjectTable4);
                            } catch (SQLException e) {
                                e.printStackTrace();
                            }
                        }
                    }
                    if(isBatchInsert){
                        try {
                            if(!CollectionUtils.isEmpty(subjectList)){
                                DbUtil.use().insert(subjectList);
                            }
                        } catch (SQLException e) {
                            e.printStackTrace();
                        }
                    }
//                }else {
//                    log.error("byCollege res is {}, request is {}  ",res,sb.toString());
//                }
            }
        }
    }

    /**
     * 学校详情
     * @param id
     * @param retry
     */
    private void detail(Integer id, Integer retry) {
        int maxRetry = 2;
        JSONObject res = null;
        try {
            String url = host + "/college/detail/" + id;
            res = ApiUtil.getInstance().httpSyncGet(url);
            if (Integer.valueOf(-1).equals(res.getInteger("error"))) {
                System.out.println(url);
                if (retry >= maxRetry) {
                    System.out.println("重试" + maxRetry + "次还不够:" + id);
                    errors.add(url + "\t" + res.getString("data"));
                    return;
                }
                ThreadUtil.safeSleep(1 * 1000);
                detail(id, retry + 1);
            } else {
                JSONObject data = res.getJSONObject("data");
                data.remove("rankMap");
                data.remove("collegeDetailHotMajor");
                data.remove("yuanxiList");
                Entity record = Entity.create("college");
                record.putAll(data);
                DbUtil.use().insertOrUpdate(record, "id");
            }
        } catch (IOException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }
    }

    private void xuanke(Integer collegeId) {
        List<Integer> years = new ArrayList<Integer>(2);
        Integer provinceId = ApiUtil.getInstance().getUser().getProvinceId();
        try {
            JSONObject res = ApiUtil.getInstance().httpSyncGet(host + "/years?provinceId=" + provinceId + "&queryType=4");
            JSONArray rows = res.getJSONArray("data");
            for (int i = 0; i < rows.size(); i++) {
                years.add(rows.getJSONObject(i).getInteger("year"));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        List<Entity> records = new ArrayList<>(12);
        for (Integer year : years) {
            int count = 0, total = 100, page = 1;
            do {
                try {
                    StringBuilder sb = new StringBuilder();
                    sb.append(host).append("/xuanke/list/byCollegeId");
                    sb.append("?provinceId=").append(provinceId);
                    sb.append("&collegeId=").append(collegeId);
                    sb.append("&year=").append(year);
                    sb.append("&page=").append(page).append("&pageSize=30");
                    JSONObject res = ApiUtil.getInstance().httpSyncGet(sb.toString());
                    JSONArray rows = res.getJSONArray("data");
                    for (int i = 0; i < rows.size(); i++) {
                        JSONObject row = rows.getJSONObject(i);
                        row.remove("Row");
                        Entity record = Entity.create("major");
                        record.putAll(row);
                        record.set("_provinceId", provinceId).set("_collegeId", collegeId).set("_year", year);
                        records.add(record);
                    }
                    total = res.getInteger("total");
                    count = page * 30;
                    page += 1;
                } catch (Exception e) {
                    e.printStackTrace();
                }

            } while (count <= total);
        }
        try {
            DbUtil.use().del(Entity.create("major").set("CollegeID", collegeId));
            DbUtil.use().insert(records);
            // DbUtil.use()
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 获取专业列表
     */
    public void getCategoryMajor() {
        Set<Entity> MajorSubjectList = new HashSet<>();// 一级专业
        Set<Entity> MajorCategoryList = new HashSet<Entity>();// 二级专业
        Set<Entity> MajorList = new HashSet<Entity>();// 三级专业
        try {
            JSONObject res = ApiUtil.getInstance().httpSyncGet(host + "/major/allCategoryMajor");
            JSONObject data = res.getJSONObject("data");
            // JSONArray bk = data.getJSONArray("BK");
            JSONArray zk = data.getJSONArray("ZK");
            // getData(bk,"本科",MajorSubjectList,MajorCategoryList,MajorList);
            MajorSubjectList.clear();// 一级专业
            MajorCategoryList.clear();// 二级专业
            MajorList.clear();// 三级专业
            getData(zk, "专科", MajorSubjectList, MajorCategoryList, MajorList);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void getData(JSONArray bk, String Type, Set<Entity> MajorSubjectList, Set<Entity> MajorCategoryList, Set<Entity> MajorList) {
        for (int i = 0; i < bk.size(); i++) {
            JSONObject Subject = bk.getJSONObject(i);
            if ("专科".equalsIgnoreCase(Type)) {
                // 专科的ID在本科的基础上增加12
                Subject.put("ID", (Subject.getInteger("ID") + 12));
            }
            Subject.put("Type", Type);
            JSONArray CategoryArray = Subject.getJSONArray("Category");
            Subject.remove("Category");
            Entity subjectTable = Entity.create("sy_major_subject");
            subjectTable.putAll(Subject);

            MajorSubjectList.add(subjectTable);
            System.out.println(Type + "：MajorSubjectList：" + JSONObject.toJSONString(MajorSubjectList));

            for (int j = 0; j < CategoryArray.size(); j++) {
                JSONObject Category = CategoryArray.getJSONObject(j);
                Category.put("MajorSubjectCode", Subject.getString("SubjectCode"));// 上级ID填充下级
                Category.remove("MajorSubjectID");// ID转换为code作为关联

                Category.put("Type", Type);
                if ("专科".equalsIgnoreCase(Type)) {
                    Category.remove("ID");
                }

                // System.out.println("before Category："+Category);
                JSONArray MajorArray = Category.getJSONArray("Major");

                Category.remove("Major");
                // System.out.println("after Category："+Category);

                Entity categoryTable = Entity.create("sy_major_category");
                categoryTable.putAll(Category);
                MajorCategoryList.add(categoryTable);
                for (int k = 0; k < MajorArray.size(); k++) {
                    JSONObject Major = MajorArray.getJSONObject(k);
                    Major.put("MajorCategoryCode", Category.getString("MajorCategoryCode"));// 上级ID填充下级
                    Major.remove("MajorCategoryID");// ID转换为code关联
                    Major.put("Type", Type);
                    if ("专科".equalsIgnoreCase(Type)) {
                        Major.remove("ID");
                    }

                    Entity majorTable = Entity.create("sy_major_major");
                    majorTable.putAll(Major);
                    MajorList.add(majorTable);
                }
            }

            try {
                // DbUtil.use().del(Entity.create("sy_major_subject").set("Type", Type));
                DbUtil.use().insert(MajorSubjectList);
                MajorSubjectList.clear();

                // DbUtil.use().del(Entity.create("sy_major_category").set("Type", Type));
                DbUtil.use().insert(MajorCategoryList);
                MajorCategoryList.clear();

                // DbUtil.use().del(Entity.create("sy_major_major").set("Type", Type));
                DbUtil.use().insert(MajorList);
                MajorList.clear();

            } catch (Exception e) {
                e.printStackTrace();
            }

        }
    }

    /**
     * 随机生成9科数据
     */
    private void generateNineDate(){
        int studentCount = 75;
        int count = studentCount*20;
//        JSONArray majorArray = new JSONArray();
        List<Long> snoList = Arrays.asList(20218421074L,20218421000L,20218421001L,20218421002L,20218421003L,20218421004L,20218421005L,20218421006L,20218421007L,20218421008L,20218421009L,20218421010L,20218421011L,20218421012L,20218421013L,20218421014L,20218421015L,20218421016L,20218421017L,20218421018L,20218421019L,20218421020L,20218421021L,20218421022L,20218421023L,20218421024L,20218421025L,20218421026L,20218421027L,20218421028L,20218421029L,20218421030L,20218421031L,20218421032L,20218421033L,20218421034L,20218421035L,20218421036L,20218421037L,20218421038L,20218421039L,20218421040L,20218421041L,20218421042L,20218421043L,20218421044L,20218421045L,20218421046L,20218421047L,20218421048L,20218421049L,20218421050L,20218421051L,20218421052L,20218421053L,20218421054L,20218421055L,20218421056L,20218421057L,20218421058L,20218421059L,20218421060L,20218421061L,20218421062L,20218421063L,20218421064L,20218421065L,20218421066L,20218421067L,20218421068L,20218421069L,20218421070L,20218421071L,20218421072L,20218421073L);
        List<String> studentNameList=Arrays.asList("张明明","柯月","万辉时","游毓融","离贵","凌伯","第宁","阳云","秋芬叶","慎学发","郏仪","贝婷","翁君纯","谯朗","聂毅谦","马绍冠","双莺瑶","皇峰","国薇","戈宁榕","龙筠可","简馨","壤雁红","丁发行","储冰","涂芝宁","贝杰林","龙先伟","都芸叶","田弘康","居昭","巢环","左娜","温枝玲","冀妍眉","贝香","伊维","叔凤婷","楚香萍","辕淑","归伟承","滑育妍","羊凝琰","水言","易波","爱岩飞","郁思","嵇良乐","司新","咸涛学","百思","督宁楠","易晓佳","空凝","褚伯","荀竹萍","伯君","哈功","葛慧凤","赏壮会","汲巧君","鲜秋芸","蔺炎","殷莲","房融","宓河邦","荣澜琰","解民","汪香","正绍","洪博","池顺民","符钧","汤博盛","竺娜");
        Set<Entity> MajorList = new HashSet<Entity>();
        for (int i =0 ;i<count;i++){
            Map major=new TreeMap();
            major.put("chinese",50+(int)(100-Math.random()*80));
            major.put("math",50+(int)(100-Math.random()*80));
            major.put("english",50+(int)(100-Math.random()*80));
            major.put("physics",(int)(100-Math.random()*50));
            major.put("chemistry",(int)(100-Math.random()*50));
            major.put("biology",(int)(100-Math.random()*50));
            major.put("history",(int)(100-Math.random()*50));
            major.put("politics",(int)(100-Math.random()*50));
            major.put("geography",(int)(100-Math.random()*50));
            major.put("schoolName","长沙市100中");
            int index = i%studentCount;
            major.put("sno",snoList.get(index));
            major.put("studentName",studentNameList.get(index));
            Date now =new Date();
            major.put("create_time",now);
            major.put("update_time",now);

            Entity majorTable = Entity.create("major_nine_copy1");
            majorTable.putAll(major);

            MajorList.add(majorTable);

            try {
//                DbUtil.use().insertOrUpdate(majorTable,"sno");
                DbUtil.use().insert(majorTable);
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }


//        try {
//            DbUtil.use().insert(MajorList);
//        } catch (SQLException e) {
//            e.printStackTrace();
//        }

        System.out.println("finished");

    }

    private void getMajorData(){
        String hnMajorData="{\"result\":{\"id\":\"61d42f88dcdd5b586e188e29\",\"countCollege\":\"1186\",\"countMajor\":\"36092\",\"matchs\":{\"major_combine\":[{\"code\":\"1,2,3\",\"name\":\"物理、化学、生物\",\"count\":\"34827\",\"percent\":96,\"percentView\":\"96%\"},{\"code\":\"1,2,6\",\"name\":\"物理、化学、思想政治\",\"count\":\"34688\",\"percent\":96,\"percentView\":\"96%\"},{\"code\":\"1,2,5\",\"name\":\"物理、化学、地理\",\"count\":\"34529\",\"percent\":95,\"percentView\":\"95%\"},{\"code\":\"1,6,5\",\"name\":\"物理、思想政治、地理\",\"count\":\"18572\",\"percent\":51,\"percentView\":\"51%\"},{\"code\":\"1,3,6\",\"name\":\"物理、生物、思想政治\",\"count\":\"18540\",\"percent\":51,\"percentView\":\"51%\"},{\"code\":\"1,3,5\",\"name\":\"物理、生物、地理\",\"count\":\"18380\",\"percent\":50,\"percentView\":\"50%\"},{\"code\":\"4,6,5\",\"name\":\"历史、思想政治、地理\",\"count\":\"17145\",\"percent\":47,\"percentView\":\"47%\"},{\"code\":\"4,3,6\",\"name\":\"历史、生物、思想政治\",\"count\":\"17041\",\"percent\":47,\"percentView\":\"47%\"},{\"code\":\"4,2,6\",\"name\":\"历史、化学、思想政治\",\"count\":\"17036\",\"percent\":47,\"percentView\":\"47%\"},{\"code\":\"4,3,5\",\"name\":\"历史、生物、地理\",\"count\":\"16792\",\"percent\":46,\"percentView\":\"46%\"},{\"code\":\"4,2,5\",\"name\":\"历史、化学、地理\",\"count\":\"16788\",\"percent\":46,\"percentView\":\"46%\"},{\"code\":\"4,2,3\",\"name\":\"历史、化学、生物\",\"count\":\"16725\",\"percent\":46,\"percentView\":\"46%\"}],\"college_combine\":[],\"major_subject\":[{\"code\":\"\",\"name\":\"物理\",\"count\":\"19568\",\"percent\":54,\"percentView\":\"54%\"},{\"code\":\"\",\"name\":\"化学\",\"count\":\"16707\",\"percent\":46,\"percentView\":\"46%\"},{\"code\":\"\",\"name\":\"不限\",\"count\":\"15937\",\"percent\":44,\"percentView\":\"44%\"},{\"code\":\"\",\"name\":\"历史\",\"count\":\"1544\",\"percent\":4,\"percentView\":\"4%\"},{\"code\":\"\",\"name\":\"生物\",\"count\":\"565\",\"percent\":1,\"percentView\":\"1%\"},{\"code\":\"\",\"name\":\"思想政治\",\"count\":\"529\",\"percent\":1,\"percentView\":\"1%\"},{\"code\":\"\",\"name\":\"地理\",\"count\":\"307\",\"percent\":1,\"percentView\":\"1%\"}],\"college_subject\":[]}},\"code\":\"\",\"message\":\"\",\"fullMessage\":\"\",\"timestamp\":\"2022-05-07T16:06:33.0794444+08:00\",\"isSuccess\":true}";
        JSONObject jsonObject= JSONObject.parseObject(hnMajorData);
        JSONObject result = jsonObject.getJSONObject("result");
        String countCollege = result.getString("countCollege");
        String countMajor = result.getString("countMajor");
        String id = result.getString("id");
        JSONArray major_combine = result.getJSONObject("matchs").getJSONArray("major_combine");
        JSONArray major_subject = result.getJSONObject("matchs").getJSONArray("major_subject");

        System.out.println(major_combine);
        System.out.println(major_subject);
    }
}
